org.codehaus.groovy.transform

## Class StaticTypesTransformation

- java.lang.Object
- - org.codehaus.groovy.transform.StaticTypesTransformation

All Implemented Interfaces:
  CompilationUnitAware, ASTTransformation

Direct Known Subclasses:
  StaticCompileTransformation

    public class StaticTypesTransformation
    extends java.lang.Object
    implements ASTTransformation, CompilationUnitAware

Handles the implementation of the `TypeChecked` transformation.

Author:
  Jochen "blackdrag" Theodorou, Cedric Champeau, Guillaume Laforge

### Field Summary

Fields
`protected CompilationUnit` `compilationUnit`
`static java.lang.String` `STATIC_ERROR_PREFIX`

### Constructor Summary

Constructors
Constructor and Description
`StaticTypesTransformation()`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected void` `addTypeCheckingExtensions(StaticTypeCheckingVisitor visitor, Expression extensions)`
`protected StaticTypeCheckingVisitor` `newVisitor(SourceUnit unit, ClassNode node)` Allows subclasses to provide their own visitor.
`void` `setCompilationUnit(CompilationUnit unit)`
`void` `visit(ASTNode[] nodes, SourceUnit source)` The method is invoked when an AST Transformation is active.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### STATIC_ERROR_PREFIX

    public static final java.lang.String STATIC_ERROR_PREFIX

See Also:
  Constant Field Values

#### compilationUnit

    protected CompilationUnit compilationUnit

### Constructor Detail

#### StaticTypesTransformation

    public StaticTypesTransformation()

### Method Detail

#### visit

    public void visit(ASTNode[] nodes,
                      SourceUnit source)

Description copied from interface: `ASTTransformation`
The method is invoked when an AST Transformation is active. For local transformations, it is invoked once each time the local annotation is encountered. For global transformations, it is invoked once for every source unit, which is typically a source file.

Specified by:
  `visit` in interface `ASTTransformation`
Parameters:
  `nodes` - The ASTnodes when the call was triggered. Element 0 is the AnnotationNode that triggered this annotation to be activated. Element 1 is the AnnotatedNode decorated, such as a MethodNode or ClassNode. For global transformations it is usually safe to ignore this parameter.
  `source` - The source unit being compiled. The source unit may contain several classes. For global transformations, information about the AST can be retrieved from this object.

#### addTypeCheckingExtensions

    protected void addTypeCheckingExtensions(StaticTypeCheckingVisitor visitor,
                                             Expression extensions)

#### newVisitor

    protected StaticTypeCheckingVisitor newVisitor(SourceUnit unit,
                                                   ClassNode node)

Allows subclasses to provide their own visitor. This is useful for example for transformations relying on the static type checker.

Parameters:
  `unit` - the source unit
  `node` - the current classnode
Returns:
  a static type checking visitor

#### setCompilationUnit

    public void setCompilationUnit(CompilationUnit unit)

Specified by:
  `setCompilationUnit` in interface `CompilationUnitAware`